#!/bin/bash
# ============LICENSE_START=======================================================
#  Copyright (C) 2020 The Nordix Foundation. All rights reserved.
# ================================================================================
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# SPDX-License-Identifier: Apache-2.0
# ============LICENSE_END=========================================================

set -o errexit
set -o nounset
set -o pipefail

# Turn PROJECTS and PROJECT_DIRECTORIES paramter strings into arrays
PROJECTS=(`echo $PROJECTS | sed 's/,/\n/g'`)
PROJECT_DIRECTORIES=(`echo $PROJECT_DIRECTORIES | sed 's/,/\n/g'`)

# Find and store array lenth of one of the arrays
ARRAY_LENGTH=$(echo ${#PROJECTS[@]})
# Take 1 of the array length for the loop
((ARRAY_LENGTH--))

# Do a Maven clean for each project source repository
# Required to reduce filesize before archiving source repositories together 
for i in $(seq 0 $ARRAY_LENGTH)
do
  echo "----------------------------------------------------"
  echo "INFO: Maven Clean for ${PROJECTS[$i]}"
  echo "----------------------------------------------------"
  $MVN clean -f $WORKSPACE/${PROJECT_DIRECTORIES[$i]}
done
